'use strict';

var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var baseTruths = ["1", "true", "+", "t", "yes", "y"];
var baseFalses = ["0", "false", "-", "f", "no", "n"];
function resolveBoolean(parameter, customs) {
  const boolean = parameter.toLowerCase();
  if ([...baseTruths, ...customs?.truths ?? []].includes(boolean)) {
    return result.Result.ok(true);
  }
  if ([...baseFalses, ...customs?.falses ?? []].includes(boolean)) {
    return result.Result.ok(false);
  }
  return result.Result.err(Identifiers_cjs.Identifiers.ArgumentBooleanError);
}
__name(resolveBoolean, "resolveBoolean");

exports.resolveBoolean = resolveBoolean;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=boolean.cjs.map