'use strict';

var discord_jsUtilities = require('@sapphire/discord.js-utilities');
var pieces = require('@sapphire/pieces');
var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveChannel(parameter, messageOrInteraction) {
  const channelId = discord_jsUtilities.ChannelMentionRegex.exec(parameter)?.[1] ?? parameter;
  const channel = (messageOrInteraction.guild ? messageOrInteraction.guild.channels : pieces.container.client.channels).cache.get(channelId);
  if (channel) {
    return result.Result.ok(channel);
  }
  return result.Result.err(Identifiers_cjs.Identifiers.ArgumentChannelError);
}
__name(resolveChannel, "resolveChannel");

exports.resolveChannel = resolveChannel;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=channel.cjs.map