'use strict';

var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveDate(parameter, options) {
  const parsed = new Date(parameter);
  const time = parsed.getTime();
  if (Number.isNaN(time)) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentDateError);
  }
  if (typeof options?.minimum === "number" && time < options.minimum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentDateTooEarly);
  }
  if (typeof options?.maximum === "number" && time > options.maximum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentDateTooFar);
  }
  return result.Result.ok(parsed);
}
__name(resolveDate, "resolveDate");

exports.resolveDate = resolveDate;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=date.cjs.map