'use strict';

var discordUtilities = require('@sapphire/discord-utilities');
var result = require('@sapphire/result');
var discord_js = require('discord.js');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveEmoji(parameter) {
  const twemoji = discordUtilities.TwemojiRegex.exec(parameter)?.[0] ?? null;
  if (twemoji) {
    return result.Result.ok({
      name: twemoji,
      id: null
    });
  }
  const emojiId = discordUtilities.EmojiRegex.test(parameter);
  if (emojiId) {
    const resolved = discord_js.parseEmoji(parameter);
    if (resolved) {
      return result.Result.ok(resolved);
    }
  }
  return result.Result.err(Identifiers_cjs.Identifiers.ArgumentEmojiError);
}
__name(resolveEmoji, "resolveEmoji");

exports.resolveEmoji = resolveEmoji;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=emoji.cjs.map