'use strict';

var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveNumber(parameter, options) {
  const parsed = Number(parameter);
  if (Number.isNaN(parsed)) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentNumberError);
  }
  if (typeof options?.minimum === "number" && parsed < options.minimum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentNumberTooSmall);
  }
  if (typeof options?.maximum === "number" && parsed > options.maximum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentNumberTooLarge);
  }
  return result.Result.ok(parsed);
}
__name(resolveNumber, "resolveNumber");

exports.resolveNumber = resolveNumber;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=number.cjs.map