'use strict';

var discordUtilities = require('@sapphire/discord-utilities');
var pieces = require('@sapphire/pieces');
var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
async function resolveUser(parameter) {
  const userId = discordUtilities.UserOrMemberMentionRegex.exec(parameter) ?? discordUtilities.SnowflakeRegex.exec(parameter);
  const user = userId ? await pieces.container.client.users.fetch(userId[1]).catch(() => null) : null;
  if (user) {
    return result.Result.ok(user);
  }
  return result.Result.err(Identifiers_cjs.Identifiers.ArgumentUserError);
}
__name(resolveUser, "resolveUser");

exports.resolveUser = resolveUser;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=user.cjs.map