'use strict';

var pieces = require('@sapphire/pieces');
var CoreChatInputCommandError_cjs = require('./CoreChatInputCommandError.cjs');
var CoreCommandApplicationCommandRegistryError_cjs = require('./CoreCommandApplicationCommandRegistryError.cjs');
var CoreCommandAutocompleteInteractionError_cjs = require('./CoreCommandAutocompleteInteractionError.cjs');
var CoreContextMenuCommandError_cjs = require('./CoreContextMenuCommandError.cjs');
var CoreInteractionHandlerError_cjs = require('./CoreInteractionHandlerError.cjs');
var CoreInteractionHandlerParseError_cjs = require('./CoreInteractionHandlerParseError.cjs');
var CoreListenerError_cjs = require('./CoreListenerError.cjs');
var CoreMessageCommandError_cjs = require('./CoreMessageCommandError.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function loadErrorListeners() {
  const store = "listeners";
  void pieces.container.stores.loadPiece({ name: "CoreChatInputCommandError", piece: CoreChatInputCommandError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreCommandApplicationCommandRegistryError", piece: CoreCommandApplicationCommandRegistryError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreCommandAutocompleteInteractionError", piece: CoreCommandAutocompleteInteractionError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreContextMenuCommandError", piece: CoreContextMenuCommandError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreInteractionHandlerError", piece: CoreInteractionHandlerError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreInteractionHandlerParseError", piece: CoreInteractionHandlerParseError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreListenerError", piece: CoreListenerError_cjs.CoreListener, store });
  void pieces.container.stores.loadPiece({ name: "CoreMessageCommandError", piece: CoreMessageCommandError_cjs.CoreListener, store });
}
__name(loadErrorListeners, "loadErrorListeners");

exports.loadErrorListeners = loadErrorListeners;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=_load.cjs.map