import { __name } from '../chunk-G5GHKT7C.mjs';
import { container } from '@sapphire/pieces';
import { resolveHyperlink } from '../lib/resolvers/hyperlink.mjs';
import { Argument } from '../lib/structures/Argument.mjs';

var _CoreArgument = class _CoreArgument extends Argument {
  constructor(context) {
    super(context, { name: "hyperlink", aliases: ["url"] });
  }
  run(parameter, context) {
    const resolved = resolveHyperlink(parameter);
    return resolved.mapErrInto(
      (identifier) => this.error({
        parameter,
        identifier,
        message: "The argument did not resolve to a valid URL.",
        context
      })
    );
  }
};
__name(_CoreArgument, "CoreArgument");
var CoreArgument = _CoreArgument;
void container.stores.loadPiece({
  name: "hyperlink",
  piece: CoreArgument,
  store: "arguments"
});

export { CoreArgument };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreHyperlink.mjs.map