import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

var baseTruths = ["1", "true", "+", "t", "yes", "y"];
var baseFalses = ["0", "false", "-", "f", "no", "n"];
function resolveBoolean(parameter, customs) {
  const boolean = parameter.toLowerCase();
  if ([...baseTruths, ...customs?.truths ?? []].includes(boolean)) {
    return Result.ok(true);
  }
  if ([...baseFalses, ...customs?.falses ?? []].includes(boolean)) {
    return Result.ok(false);
  }
  return Result.err(Identifiers.ArgumentBooleanError);
}
__name(resolveBoolean, "resolveBoolean");

export { resolveBoolean };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=boolean.mjs.map