import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveDate(parameter, options) {
  const parsed = new Date(parameter);
  const time = parsed.getTime();
  if (Number.isNaN(time)) {
    return Result.err(Identifiers.ArgumentDateError);
  }
  if (typeof options?.minimum === "number" && time < options.minimum) {
    return Result.err(Identifiers.ArgumentDateTooEarly);
  }
  if (typeof options?.maximum === "number" && time > options.maximum) {
    return Result.err(Identifiers.ArgumentDateTooFar);
  }
  return Result.ok(parsed);
}
__name(resolveDate, "resolveDate");

export { resolveDate };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=date.mjs.map