import { __name } from '../../chunk-G5GHKT7C.mjs';
import { TwemojiRegex, EmojiRegex } from '@sapphire/discord-utilities';
import { Result } from '@sapphire/result';
import { parseEmoji } from 'discord.js';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveEmoji(parameter) {
  const twemoji = TwemojiRegex.exec(parameter)?.[0] ?? null;
  if (twemoji) {
    return Result.ok({
      name: twemoji,
      id: null
    });
  }
  const emojiId = EmojiRegex.test(parameter);
  if (emojiId) {
    const resolved = parseEmoji(parameter);
    if (resolved) {
      return Result.ok(resolved);
    }
  }
  return Result.err(Identifiers.ArgumentEmojiError);
}
__name(resolveEmoji, "resolveEmoji");

export { resolveEmoji };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=emoji.mjs.map