import { __name } from '../../chunk-G5GHKT7C.mjs';
import { SnowflakeRegex } from '@sapphire/discord-utilities';
import { container } from '@sapphire/pieces';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

async function resolveGuild(parameter) {
  const guildId = SnowflakeRegex.exec(parameter)?.groups?.id;
  const guild = guildId ? await container.client.guilds.fetch(guildId).catch(() => null) : null;
  if (guild) {
    return Result.ok(guild);
  }
  return Result.err(Identifiers.ArgumentGuildError);
}
__name(resolveGuild, "resolveGuild");

export { resolveGuild };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=guild.mjs.map