import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveInteger(parameter, options) {
  const parsed = Number(parameter);
  if (!Number.isInteger(parsed)) {
    return Result.err(Identifiers.ArgumentIntegerError);
  }
  if (typeof options?.minimum === "number" && parsed < options.minimum) {
    return Result.err(Identifiers.ArgumentIntegerTooSmall);
  }
  if (typeof options?.maximum === "number" && parsed > options.maximum) {
    return Result.err(Identifiers.ArgumentIntegerTooLarge);
  }
  return Result.ok(parsed);
}
__name(resolveInteger, "resolveInteger");

export { resolveInteger };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=integer.mjs.map