import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveString(parameter, options) {
  if (typeof options?.minimum === "number" && parameter.length < options.minimum) {
    return Result.err(Identifiers.ArgumentStringTooShort);
  }
  if (typeof options?.maximum === "number" && parameter.length > options.maximum) {
    return Result.err(Identifiers.ArgumentStringTooLong);
  }
  return Result.ok(parameter);
}
__name(resolveString, "resolveString");

export { resolveString };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=string.mjs.map