import { __name } from '../../chunk-G5GHKT7C.mjs';
import { LoaderStrategy } from '@sapphire/pieces';

var _ListenerLoaderStrategy = class _ListenerLoaderStrategy extends LoaderStrategy {
  onLoad(_store, piece) {
    const listenerCallback = piece["_listener"];
    if (listenerCallback) {
      const emitter = piece.emitter;
      const maxListeners = emitter.getMaxListeners();
      if (maxListeners !== 0)
        emitter.setMaxListeners(maxListeners + 1);
      emitter[piece.once ? "once" : "on"](piece.event, listenerCallback);
    }
  }
  onUnload(_store, piece) {
    const listenerCallback = piece["_listener"];
    if (!piece.once && listenerCallback) {
      const emitter = piece.emitter;
      const maxListeners = emitter.getMaxListeners();
      if (maxListeners !== 0)
        emitter.setMaxListeners(maxListeners - 1);
      emitter.off(piece.event, listenerCallback);
      piece["_listener"] = null;
    }
  }
};
__name(_ListenerLoaderStrategy, "ListenerLoaderStrategy");
var ListenerLoaderStrategy = _ListenerLoaderStrategy;

export { ListenerLoaderStrategy };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=ListenerLoaderStrategy.mjs.map