import { __name } from '../../../chunk-G5GHKT7C.mjs';
import { container } from '@sapphire/pieces';
import { Events } from '../../types/Events.mjs';
import { bulkOverwriteError } from './registriesLog.mjs';

function emitPerRegistryError(error, command) {
  const { name, location } = command;
  const { client, logger } = container;
  if (client.listenerCount(Events.CommandApplicationCommandRegistryError)) {
    client.emit(Events.CommandApplicationCommandRegistryError, error, command);
  } else {
    logger.error(
      `Encountered error while handling the command application command registry for command "${name}" at path "${location.full}"`,
      error
    );
  }
}
__name(emitPerRegistryError, "emitPerRegistryError");
function emitBulkOverwriteError(error, guildId) {
  const { client } = container;
  if (client.listenerCount(Events.ApplicationCommandRegistriesBulkOverwriteError)) {
    client.emit(Events.ApplicationCommandRegistriesBulkOverwriteError, error, guildId);
  } else if (guildId) {
    bulkOverwriteError(`Failed to overwrite guild application commands for guild ${guildId}`, error);
  } else {
    bulkOverwriteError(`Failed to overwrite global application commands`, error);
  }
}
__name(emitBulkOverwriteError, "emitBulkOverwriteError");

export { emitBulkOverwriteError, emitPerRegistryError };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=registriesErrors.mjs.map