import { __name } from '../../../chunk-G5GHKT7C.mjs';
import { container } from '@sapphire/pieces';
import { Listener } from '../../../lib/structures/Listener.mjs';
import { Events } from '../../../lib/types/Events.mjs';

var _CoreListener = class _CoreListener extends Listener {
  constructor(context) {
    super(context, { event: Events.PreContextMenuCommandRun });
  }
  async run(payload) {
    const { command, interaction } = payload;
    const globalResult = await this.container.stores.get("preconditions").contextMenuRun(interaction, command, payload);
    if (globalResult.isErr()) {
      this.container.client.emit(Events.ContextMenuCommandDenied, globalResult.unwrapErr(), payload);
      return;
    }
    const localResult = await command.preconditions.contextMenuRun(interaction, command, payload);
    if (localResult.isErr()) {
      this.container.client.emit(Events.ContextMenuCommandDenied, localResult.unwrapErr(), payload);
      return;
    }
    this.container.client.emit(Events.ContextMenuCommandAccepted, payload);
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;
void container.stores.loadPiece({
  name: "CorePreContextMenuCommandRun",
  piece: CoreListener,
  store: "listeners"
});

export { CoreListener };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CorePreContextMenuCommandRun.mjs.map