import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Listener } from '../../lib/structures/Listener.mjs';
import { Events } from '../../lib/types/Events.mjs';

var _CoreListener = class _CoreListener extends Listener {
  constructor(context) {
    super(context, { event: Events.PreMessageCommandRun });
  }
  async run(payload) {
    const { message, command } = payload;
    const globalResult = await this.container.stores.get("preconditions").messageRun(message, command, payload);
    if (globalResult.isErr()) {
      message.client.emit(Events.MessageCommandDenied, globalResult.unwrapErr(), payload);
      return;
    }
    const localResult = await command.preconditions.messageRun(message, command, payload);
    if (localResult.isErr()) {
      message.client.emit(Events.MessageCommandDenied, localResult.unwrapErr(), payload);
      return;
    }
    message.client.emit(Events.MessageCommandAccepted, payload);
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;

export { CoreListener };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CorePreMessageCommandRun.mjs.map