import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Listener } from '../../lib/structures/Listener.mjs';
import { Events } from '../../lib/types/Events.mjs';

var _CoreListener = class _CoreListener extends Listener {
  constructor(context) {
    super(context, { event: Events.PrefixedMessage });
  }
  run(message, prefix) {
    const { client, stores } = this.container;
    const commandPrefix = this.getCommandPrefix(message.content, prefix);
    const prefixLess = message.content.slice(commandPrefix.length).trim();
    const spaceIndex = prefixLess.indexOf(" ");
    const commandName = spaceIndex === -1 ? prefixLess : prefixLess.slice(0, spaceIndex);
    if (commandName.length === 0) {
      client.emit(Events.UnknownMessageCommandName, { message, prefix, commandPrefix });
      return;
    }
    const command = stores.get("commands").get(client.options.caseInsensitiveCommands ? commandName.toLowerCase() : commandName);
    if (!command) {
      client.emit(Events.UnknownMessageCommand, { message, prefix, commandName, commandPrefix });
      return;
    }
    if (!command.messageRun) {
      client.emit(Events.CommandDoesNotHaveMessageCommandHandler, { message, prefix, commandPrefix, command });
      return;
    }
    const parameters = spaceIndex === -1 ? "" : prefixLess.substring(spaceIndex + 1).trim();
    client.emit(Events.PreMessageCommandRun, {
      message,
      command,
      parameters,
      context: { commandName, commandPrefix, prefix }
    });
  }
  getCommandPrefix(content, prefix) {
    return typeof prefix === "string" ? prefix : prefix.exec(content)[0];
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;

export { CoreListener };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CorePrefixedMessage.mjs.map