'use strict';

var fs = require('fs');
var path = require('path');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var data = null;
function dirnameWithPath(cwd, joinablePath) {
  return path.dirname(path.join(cwd, joinablePath));
}
__name(dirnameWithPath, "dirnameWithPath");
function getRootData() {
  return data ??= parseRootData();
}
__name(getRootData, "getRootData");
function parseRootData() {
  const cwd = process.cwd();
  let file;
  try {
    file = JSON.parse(fs.readFileSync(path.join(cwd, "package.json"), "utf8"));
  } catch (error) {
    return { root: cwd, type: "CommonJS" };
  }
  const { main: packageMain, module: packageModule, type: packageType } = file;
  const lowerCasedType = packageType?.toLowerCase();
  if (lowerCasedType === "commonjs") {
    if (packageMain)
      return { root: dirnameWithPath(cwd, packageMain), type: "CommonJS" };
    if (packageModule)
      return { root: dirnameWithPath(cwd, packageModule), type: "CommonJS" };
    return { root: cwd, type: "CommonJS" };
  }
  if (lowerCasedType === "module") {
    if (packageMain)
      return { root: dirnameWithPath(cwd, packageMain), type: "ESM" };
    if (packageModule)
      return { root: dirnameWithPath(cwd, packageModule), type: "ESM" };
    return { root: cwd, type: "ESM" };
  }
  if (packageMain)
    return { root: dirnameWithPath(cwd, packageMain), type: "CommonJS" };
  if (packageModule)
    return { root: dirnameWithPath(cwd, packageModule), type: "ESM" };
  return { root: cwd, type: "CommonJS" };
}
__name(parseRootData, "parseRootData");

exports.getRootData = getRootData;
exports.parseRootData = parseRootData;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=RootScan.cjs.map