# Changelog

All notable changes to this project will be documented in this file.

# [@sapphire/utilities@3.16.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.16.1...@sapphire/utilities@3.16.2) - (2024-05-21)

## 🐛 Bug Fixes

- **utilities:** Update re-exports on index level ([902cee8](https://github.com/sapphiredev/utilities/commit/902cee88b1e744d6748aa5c3c2e1c038d9d7dbbc))

# [@sapphire/utilities@3.16.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.16.0...@sapphire/utilities@3.16.1) - (2024-05-21)

## 🐛 Bug Fixes

- **utilities:** Fixed cjs bundle ([f1db3f6](https://github.com/sapphiredev/utilities/commit/f1db3f6e09d67a5d769ee01db60d100f7af75426))

# [@sapphire/utilities@3.16.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.15.3...@sapphire/utilities@3.16.0) - (2024-05-20)

## 📝 Documentation

- **readme:** Fix readme table of contents ([c60e8bd](https://github.com/sapphiredev/utilities/commit/c60e8bd9fc89156cf973871597ec3f0ef0308c08))
- **utilities:** Fix tsdoc comments for `debounce` ([e9f4de9](https://github.com/sapphiredev/utilities/commit/e9f4de9bca5fb28cddf9c77b6c176fa7686cdaba))

## 🚀 Features

- **utilities:** Add `capitalizeFirstLetter`, `hasAtLeastOneKeyInObject`, and `snakeToCamelCase` (#747) ([014e4e8](https://github.com/sapphiredev/utilities/commit/014e4e8765943fc09d86b75fa347cc68102575b7))

# [@sapphire/utilities@3.15.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.15.3...@sapphire/utilities@3.15.3) - (2024-01-19)

## 🐛 Bug Fixes

- Fixed commonjs typings export mapping (#707) ([216ff02](https://github.com/sapphiredev/utilities/commit/216ff0260d63a9590357f9a5069f1ae2b34eaf5d))

# [@sapphire/utilities@3.15.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.15.2...@sapphire/utilities@3.15.2) - (2024-01-06)

## 🐛 Bug Fixes

- Fixed bun compatibility for @sapphire/utilities (#703) ([ba07362](https://github.com/sapphiredev/utilities/commit/ba07362e08bce895d4ada672d65edb527fcfc26d))

# [@sapphire/utilities@3.15.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.15.1...@sapphire/utilities@3.15.1) - (2023-12-28)

## 📝 Documentation

- **utilities:** Fix tsdoc comments for omitKeysFromObject ([afd7d27](https://github.com/sapphiredev/utilities/commit/afd7d2742fbca4d1c84fa0b6855490ce644a1899))

# [@sapphire/utilities@3.15.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.15.0...@sapphire/utilities@3.15.0) - (2023-12-28)

## 🚀 Features

- **utilities:** Add omitKeysFromObject utility function (#700) ([eccf9f6](https://github.com/sapphiredev/utilities/commit/eccf9f679581d95a7d2b29ae894a6971edcb4cc3))

## 🪞 Styling

- Run prettier on the codebase ([1d6e994](https://github.com/sapphiredev/utilities/commit/1d6e9941833b674eebb245d272ce879ce6a70427))

# [@sapphire/utilities@3.14.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.14.0...@sapphire/utilities@3.14.0) - (2023-12-04)

## 🐛 Bug Fixes

- **utilities:** Properly split CJS, ESM and IIFE ([f9d8c8e](https://github.com/sapphiredev/utilities/commit/f9d8c8ec9b196ef34820a11f2612c8ae7588c0d3))
- **discord.js-utilities:** Fixed `isNsfwChannel` typeguard by including `ChannelType.GuildMedia` (#665) ([7c6cfe2](https://github.com/sapphiredev/utilities/commit/7c6cfe239ba660fcf4e58a50e7691a2e622c0fda))

## 📝 Documentation

- **utilities:** Improve typedoc ([16c05ea](https://github.com/sapphiredev/utilities/commit/16c05eab3ae464b109b7fbc24364135111c22d98))

## 🚀 Features

- **tryParseJSON:** Support `replacer` argument (#668) ([4cf0978](https://github.com/sapphiredev/utilities/commit/4cf0978ed608a48164af0d5a027b72990f32124b))

# [@sapphire/utilities@3.13.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.12.0...@sapphire/utilities@3.13.0) - (2023-07-21)

## 🏠 Refactor

- **sleep:** Align more closely with the Node.js API. This removes the `AbortError` class, if you were previously using it then check for `instanceof DOMException` and `error.name === 'AbortError'` (#626) ([36cd38f](https://github.com/sapphiredev/utilities/commit/36cd38f75c1cbea4f9a30149e18ea5255fde2be9))
- **utilities:** Make sleepSync its own file (#615) ([5838b7e](https://github.com/sapphiredev/utilities/commit/5838b7e32e7d0cbf455f259e22c6aeaae5f18ec0))

## 🐛 Bug Fixes

- **deps:** Update all non-major dependencies (#607) ([9cc8bd0](https://github.com/sapphiredev/utilities/commit/9cc8bd0d4b5d650deab2c913e6c3d713861bae28))

## 🚀 Features

- **utilities:** Add poll function (#616) ([59d4c6b](https://github.com/sapphiredev/utilities/commit/59d4c6b986f8f363e32ec6297921d999201b0930))

## 🧪 Testing

- **sleepSync:** Use spies for `Date.now()` (#617) ([cf444df](https://github.com/sapphiredev/utilities/commit/cf444df3c4a63ac039de9cf4fe56b86f2068f1e2))
- **pickRandom:** Add test to cover empty arrays ([b74394a](https://github.com/sapphiredev/utilities/commit/b74394a1a09ce8aaa14f4084e7a1105284e08205))

# [@sapphire/utilities@3.12.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.11.2...@sapphire/utilities@3.12.0) - (2023-06-09)

## 🚀 Features

- **utilities:** Add retry function (#604) ([37dee25](https://github.com/sapphiredev/utilities/commit/37dee25f403fbc7bbe4703651367cbf0cbb1d2aa))

## 🧪 Testing

- Update vitest to coverage v8 ([a4bc6e4](https://github.com/sapphiredev/utilities/commit/a4bc6e4f24ea60143a150ecc76fda6484f172ab9))

# [@sapphire/utilities@3.11.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.11.1...@sapphire/utilities@3.11.2) - (2023-05-06)

## 🐛 Bug Fixes

- **utilities:** Add support for TypedArray to deepClone (#592) ([85dcd15](https://github.com/sapphiredev/utilities/commit/85dcd15fd98fff5bf74749d2cd26963a99c71a75))

# [@sapphire/utilities@3.11.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.11.0...@sapphire/utilities@3.11.1) - (2023-04-10)

## 🏃 Performance

- **chunk:** Remove clone (#574) ([049047b](https://github.com/sapphiredev/utilities/commit/049047b3ceee6fcfeb2e09e15e26424022a5045c))

## 🏠 Refactor

- **utilities:** Improve `codeBlock` and `inlineCodeBlock` (#498) ([29b1e5a](https://github.com/sapphiredev/utilities/commit/29b1e5a21317142ca6cceea5d4eaf65e9243653e))

## 🐛 Bug Fixes

- **deps:** Update all non-major dependencies (#577) ([291dd67](https://github.com/sapphiredev/utilities/commit/291dd6783e57d8f075ce566218ba076ef6c4bbbd))
- **deps:** Update all non-major dependencies (#545) ([40ca040](https://github.com/sapphiredev/utilities/commit/40ca040a21d8a0949682051a3a974538183a400e))
- **deps:** Update all non-major dependencies (#544) ([cc78f17](https://github.com/sapphiredev/utilities/commit/cc78f17390c7f3db08af92bf46a5a70a9c11dd5f))
- **deps:** Update all non-major dependencies (#532) ([8033d1f](https://github.com/sapphiredev/utilities/commit/8033d1ff7a5a1974134c61f424f171cccb2915e1))
- **deps:** Update all non-major dependencies (#514) ([21b07d5](https://github.com/sapphiredev/utilities/commit/21b07d5db529a0d982647a60de98e46f36f1ac93))
- **deps:** Update all non-major dependencies (#505) ([6178296](https://github.com/sapphiredev/utilities/commit/617829649e1e4deeee02b14533b5377cd5bc1fb3))

## 📝 Documentation

- Add @06000208 as a contributor ([fa3349e](https://github.com/sapphiredev/utilities/commit/fa3349e55ce4ad008785211dec7bf8e2b5d933df))
- Add @didinele as a contributor ([42ef7b6](https://github.com/sapphiredev/utilities/commit/42ef7b656c48fd0e720119db1d622c8bba2791e9))
- Add @goestav as a contributor ([0e56a92](https://github.com/sapphiredev/utilities/commit/0e56a92a4e2d0942bfa207f81a8cb03b32312034))
- Add @CitTheDev as a contributor ([34169ea](https://github.com/sapphiredev/utilities/commit/34169eae1dc0476ccf5a6c4f36e28602a204829e))
- Add @legendhimslef as a contributor ([059b6f1](https://github.com/sapphiredev/utilities/commit/059b6f1ab5362d46d58624d06c1aa39192b0716f))
- **utilities:** Add usage (#499) ([0c4decc](https://github.com/sapphiredev/utilities/commit/0c4decc879cb531d82fe4c871b6fe6a7b3e1314b))

## 🧪 Testing

- Cleanup tests ([aec1bb2](https://github.com/sapphiredev/utilities/commit/aec1bb290d0f3c00a1ae4f4c86302ebbb161d348))

# [@sapphire/utilities@3.11.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.10.1...@sapphire/utilities@3.11.0) - (2022-10-08)

## 🐛 Bug Fixes

- Override deprecated jsdoc (#488) ([5cc9a2c](https://github.com/sapphiredev/utilities/commit/5cc9a2ca1257cdbb62a65f70cea9cacb86853704))

## 🚀 Features

- Throttle function (#483) ([541891a](https://github.com/sapphiredev/utilities/commit/541891a8fea49d06d2855aa45efb095f196cdfb0))
- **utilities:** Add pickRandom (#486) ([20823c9](https://github.com/sapphiredev/utilities/commit/20823c9ed02d1d4835b082874e5c2718b101c416))
- Added `tryParseURL` (#482) ([46c5b49](https://github.com/sapphiredev/utilities/commit/46c5b49ac08da8207c7fbc1e7c15572d136bf103))

# [@sapphire/utilities@3.10.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.10.0...@sapphire/utilities@3.10.1) - (2022-10-02)

## 🐛 Bug Fixes

- **utilities:** Add missing deprecated exports ([ef08c69](https://github.com/sapphiredev/utilities/commit/ef08c6910381df88fdada4b610f77604f5217ae1))

## 📝 Documentation

- Add @r-priyam as a contributor ([fb278ba](https://github.com/sapphiredev/utilities/commit/fb278bacf627ec6fc88752eafeb12df5f3177a2c))

# [@sapphire/utilities@3.10.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.3...@sapphire/utilities@3.10.0) - (2022-10-02)

## 🏠 Refactor

- Split `@sapphire/time-utilities` into 4 sub-packages (#462) ([574299a](https://github.com/sapphiredev/utilities/commit/574299a99e658f6500a2a7efa587a0919b2d1313))

## 🐛 Bug Fixes

- **utilities:** Fixed output file extensions (#480) ([99a011d](https://github.com/sapphiredev/utilities/commit/99a011db82cb0b012974eb26951195cf8d00b672))
- **utilities:** Specify chunk file as side effect ([7b34a81](https://github.com/sapphiredev/utilities/commit/7b34a81673f8c0e86fab40b956bffc903aa28a8f))
- **deps:** Update all non-major dependencies (#466) ([dc08606](https://github.com/sapphiredev/utilities/commit/dc08606a97154e47c65536123ac5f8b1262f7bd2))
- **deps:** Update all non-major dependencies ([e20f299](https://github.com/sapphiredev/utilities/commit/e20f29906e83cee000aaba9c6827e3bec5173d28))

## 📝 Documentation

- Change name of @kyranet (#451) ([df4fdef](https://github.com/sapphiredev/utilities/commit/df4fdefce18659975a4ebc224723638507d02d35))

## 🚀 Features

- **utilities:** Add possibility to import single functions by appending them to the import path. (#454) ([374c145](https://github.com/sapphiredev/utilities/commit/374c145a5dd329cfc1a867ed6720abf408683a88))
- **utilities:** Add `objectKeys` function (#472) ([384ff84](https://github.com/sapphiredev/utilities/commit/384ff845115c37aaeb20b0b23051954f75f1d0bf))
- **utilities:** Add `objectEntries` function (#471) ([84c1418](https://github.com/sapphiredev/utilities/commit/84c1418a1b60dcc61c0e74f54f4c9825ac735962))
- **utilities:** Add `objectValues` function (#474) ([90c2409](https://github.com/sapphiredev/utilities/commit/90c2409e3103575aff1dd00e0d1b5c1c10c74140))
- **utilities:** Add `sleep` and `sleepSync` (#469) ([8cd1293](https://github.com/sapphiredev/utilities/commit/8cd129382f1958e00166a8248f4d864480562829))

# [@sapphire/utilities@3.10.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.10.0...@sapphire/utilities@3.10.1) - (2022-10-02)

## 🐛 Bug Fixes

- **utilities:** Add missing deprecated exports ([ef08c69](https://github.com/sapphiredev/utilities/commit/ef08c6910381df88fdada4b610f77604f5217ae1))

## 📝 Documentation

- Add @r-priyam as a contributor ([fb278ba](https://github.com/sapphiredev/utilities/commit/fb278bacf627ec6fc88752eafeb12df5f3177a2c))

# [@sapphire/utilities@3.10.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.3...@sapphire/utilities@3.10.0) - (2022-10-02)

## 🏠 Refactor

- Split `@sapphire/time-utilities` into 4 sub-packages (#462) ([574299a](https://github.com/sapphiredev/utilities/commit/574299a99e658f6500a2a7efa587a0919b2d1313))

## 🐛 Bug Fixes

- **utilities:** Fixed output file extensions (#480) ([99a011d](https://github.com/sapphiredev/utilities/commit/99a011db82cb0b012974eb26951195cf8d00b672))
- **utilities:** Specify chunk file as side effect ([7b34a81](https://github.com/sapphiredev/utilities/commit/7b34a81673f8c0e86fab40b956bffc903aa28a8f))
- **deps:** Update all non-major dependencies (#466) ([dc08606](https://github.com/sapphiredev/utilities/commit/dc08606a97154e47c65536123ac5f8b1262f7bd2))
- **deps:** Update all non-major dependencies ([e20f299](https://github.com/sapphiredev/utilities/commit/e20f29906e83cee000aaba9c6827e3bec5173d28))

## 📝 Documentation

- Change name of @kyranet (#451) ([df4fdef](https://github.com/sapphiredev/utilities/commit/df4fdefce18659975a4ebc224723638507d02d35))

## 🚀 Features

- **utilities:** Add possibility to import single functions by appending them to the import path. (#454) ([374c145](https://github.com/sapphiredev/utilities/commit/374c145a5dd329cfc1a867ed6720abf408683a88))
- **utilities:** Add `objectKeys` function (#472) ([384ff84](https://github.com/sapphiredev/utilities/commit/384ff845115c37aaeb20b0b23051954f75f1d0bf))
- **utilities:** Add `objectEntries` function (#471) ([84c1418](https://github.com/sapphiredev/utilities/commit/84c1418a1b60dcc61c0e74f54f4c9825ac735962))
- **utilities:** Add `objectValues` function (#474) ([90c2409](https://github.com/sapphiredev/utilities/commit/90c2409e3103575aff1dd00e0d1b5c1c10c74140))
- **utilities:** Add `sleep` and `sleepSync` (#469) ([8cd1293](https://github.com/sapphiredev/utilities/commit/8cd129382f1958e00166a8248f4d864480562829))

# [@sapphire/utilities@3.10.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.3...@sapphire/utilities@3.10.0) - (2022-10-02)

## 🏠 Refactor

- Split `@sapphire/time-utilities` into 4 sub-packages (#462) ([574299a](https://github.com/sapphiredev/utilities/commit/574299a99e658f6500a2a7efa587a0919b2d1313))

## 🐛 Bug Fixes

- **utilities:** Fixed output file extensions (#480) ([99a011d](https://github.com/sapphiredev/utilities/commit/99a011db82cb0b012974eb26951195cf8d00b672))
- **utilities:** Specify chunk file as side effect ([7b34a81](https://github.com/sapphiredev/utilities/commit/7b34a81673f8c0e86fab40b956bffc903aa28a8f))
- **deps:** Update all non-major dependencies (#466) ([dc08606](https://github.com/sapphiredev/utilities/commit/dc08606a97154e47c65536123ac5f8b1262f7bd2))
- **deps:** Update all non-major dependencies ([e20f299](https://github.com/sapphiredev/utilities/commit/e20f29906e83cee000aaba9c6827e3bec5173d28))

## 📝 Documentation

- Change name of @kyranet (#451) ([df4fdef](https://github.com/sapphiredev/utilities/commit/df4fdefce18659975a4ebc224723638507d02d35))

## 🚀 Features

- **utilities:** Add possibility to import single functions by appending them to the import path. (#454) ([374c145](https://github.com/sapphiredev/utilities/commit/374c145a5dd329cfc1a867ed6720abf408683a88))
- **utilities:** Add `objectKeys` function (#472) ([384ff84](https://github.com/sapphiredev/utilities/commit/384ff845115c37aaeb20b0b23051954f75f1d0bf))
- **utilities:** Add `objectEntries` function (#471) ([84c1418](https://github.com/sapphiredev/utilities/commit/84c1418a1b60dcc61c0e74f54f4c9825ac735962))
- **utilities:** Add `objectValues` function (#474) ([90c2409](https://github.com/sapphiredev/utilities/commit/90c2409e3103575aff1dd00e0d1b5c1c10c74140))
- **utilities:** Add `sleep` and `sleepSync` (#469) ([8cd1293](https://github.com/sapphiredev/utilities/commit/8cd129382f1958e00166a8248f4d864480562829))

# [@sapphire/utilities@3.9.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.2...@sapphire/utilities@3.9.3) - (2022-09-02)

## 🐛 Bug Fixes

- **isNumber:** Parse string parameter as number (allow string as parameter) (#444) ([01e1b14](https://github.com/sapphiredev/utilities/commit/01e1b1428cf793d7716d60217204626c76bd872e))

## 📝 Documentation

- Update @RealShadowNova as a contributor ([a869ba0](https://github.com/sapphiredev/utilities/commit/a869ba0abfad041610b9115187d426aebe671af6))

# [@sapphire/utilities@3.9.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.0...@sapphire/utilities@3.9.1) - (2022-08-16)

## 🐛 Bug Fixes

- **utilities:** Fixed `getDeepObjectKeys` not returning proper values for arrays of not-objects (#428) ([88f84e6](https://github.com/sapphiredev/utilities/commit/88f84e61a72e6682bfeb2b38a8a2c55de08c757e))
- **deps:** Update all non-major dependencies ([2308bd7](https://github.com/sapphiredev/utilities/commit/2308bd74356b6b2e0c12995b25f4d8ade4803fe9))

## 📝 Documentation

- Fixed typos (#427) ([e840a97](https://github.com/sapphiredev/utilities/commit/e840a9795583b59ee3da9ffe0d325e0a3cfa0c14))

# [@sapphire/utilities@3.9.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.9.0...@sapphire/utilities@3.9.1) - (2022-08-16)

## 🐛 Bug Fixes

- **utilities:** Fixed `getDeepObjectKeys` not returning proper values for arrays of not-objects (#428) ([88f84e6](https://github.com/sapphiredev/utilities/commit/88f84e61a72e6682bfeb2b38a8a2c55de08c757e))
- **deps:** Update all non-major dependencies ([2308bd7](https://github.com/sapphiredev/utilities/commit/2308bd74356b6b2e0c12995b25f4d8ade4803fe9))

## 📝 Documentation

- Fixed typos (#427) ([e840a97](https://github.com/sapphiredev/utilities/commit/e840a9795583b59ee3da9ffe0d325e0a3cfa0c14))

# [@sapphire/utilities@3.9.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.8.0...@sapphire/utilities@3.9.0) - (2022-08-04)

## 🚀 Features

- **utilities:** Add getDeepObjectKeys (#413) ([b8b0883](https://github.com/sapphiredev/utilities/commit/b8b0883689e96df30767e4c9998b5f3403560779))

# [@sapphire/utilities@3.8.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.7.0...@sapphire/utilities@3.8.0) - (2022-07-30)

## 🐛 Bug Fixes

- **deps:** Update all non-major dependencies ([84af0db](https://github.com/sapphiredev/utilities/commit/84af0db2db749223b036aa99fe19a2e9af5681c6))

## 📝 Documentation

- Add @muchnameless as a contributor ([a1221fe](https://github.com/sapphiredev/utilities/commit/a1221fea68506e99591d5d00ec552a07c26833f9))
- Add @enxg as a contributor ([d2382f0](https://github.com/sapphiredev/utilities/commit/d2382f04e3909cb4ad11798a0a10e683f6cf5383))
- Add @EvolutionX-10 as a contributor ([efc3a32](https://github.com/sapphiredev/utilities/commit/efc3a320a72ae258996dd62866d206c33f8d4961))

## 🚀 Features

- Add lazy (#406) ([80db17c](https://github.com/sapphiredev/utilities/commit/80db17cde4266a2a73639fde9670996a0814474b))

# [@sapphire/utilities@3.7.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.6.2...@sapphire/utilities@3.7.0) - (2022-07-01)

## 🏠 Refactor

- **utilities:** Make `objectToTuples` more type-safe ([664580f](https://github.com/sapphiredev/utilities/commit/664580f74ba2fdc7c9edcd277dd93214d823fb2d))

## 🐛 Bug Fixes

- **deps:** Update all non-major dependencies ([50cd8de](https://github.com/sapphiredev/utilities/commit/50cd8dea593b6f5ae75571209456b3421e2ca59a))

## 📝 Documentation

- Add @MajesticString as a contributor ([295b3e9](https://github.com/sapphiredev/utilities/commit/295b3e9849a4b0fe64074bae02f6426378a303c3))
- Add @Mzato0001 as a contributor ([c790ef2](https://github.com/sapphiredev/utilities/commit/c790ef25df2d7e22888fa9f8169167aa555e9e19))
- Add @NotKaskus as a contributor ([00da8f1](https://github.com/sapphiredev/utilities/commit/00da8f199137b9277119823f322d1f2d168d928a))
- Add @imranbarbhuiya as a contributor ([fb674c2](https://github.com/sapphiredev/utilities/commit/fb674c2c5594d41e71662263553dcb4bac9e37f4))
- Add @axisiscool as a contributor ([ce1aa31](https://github.com/sapphiredev/utilities/commit/ce1aa316871a88d3663efbdf2a42d3d8dfe6a27f))
- Add @dhruv-kaushikk as a contributor ([ebbf43f](https://github.com/sapphiredev/utilities/commit/ebbf43f63617daba96e72c50a234bf8b64f6ddc4))
- Add @Commandtechno as a contributor ([f1d69fa](https://github.com/sapphiredev/utilities/commit/f1d69fabe1ee0abe4be08b19e63dbec03102f7ce))
- Fix typedoc causing OOM crashes ([63ba41c](https://github.com/sapphiredev/utilities/commit/63ba41c4b6678554b1c7043a22d3296db4f59360))

## 🚀 Features

- **utilities:** Add `AnyObject` utility type ([e442028](https://github.com/sapphiredev/utilities/commit/e442028b07f867c31f94208b70b479893245b806))

## 🧪 Testing

- Migrate to vitest (#380) ([075ec73](https://github.com/sapphiredev/utilities/commit/075ec73c7a8e3374fad3ada612d37eb4ac36ec8d))

## [3.6.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.6.1...@sapphire/utilities@3.6.2) (2022-04-01)

**Note:** Version bump only for package @sapphire/utilities

## [3.6.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.6.0...@sapphire/utilities@3.6.1) (2022-03-20)

### Bug Fixes

-   **utilities:** remove `U` type from `cast` ([241ca66](https://github.com/sapphiredev/utilities/commit/241ca66bcecb11477c948e11c0428c31f4e34e6b))

# [3.6.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.5.0...@sapphire/utilities@3.6.0) (2022-03-20)

### Features

-   **utilities:** add `cast` method ([7e02bf5](https://github.com/sapphiredev/utilities/commit/7e02bf5b34f33c4cafb321055629c9f6a24c5ed9))

# [3.5.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.4.0...@sapphire/utilities@3.5.0) (2022-03-11)

### Features

-   **utlities:** add title case `options` param ([#313](https://github.com/sapphiredev/utilities/issues/313)) ([ca7cffa](https://github.com/sapphiredev/utilities/commit/ca7cffa015d027de6ba4121f45c0b88867aede02))

# [3.4.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.3.0...@sapphire/utilities@3.4.0) (2022-03-06)

### Features

-   allow module: NodeNext ([#306](https://github.com/sapphiredev/utilities/issues/306)) ([9dc6dd6](https://github.com/sapphiredev/utilities/commit/9dc6dd619efab879bb2b0b3c9e64304e10a67ed6))
-   **ts-config:** add multi-config structure ([#281](https://github.com/sapphiredev/utilities/issues/281)) ([b5191d7](https://github.com/sapphiredev/utilities/commit/b5191d7f2416dc5838590c4ff221454925553e37))

# [3.3.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.2.1...@sapphire/utilities@3.3.0) (2022-01-28)

### Bug Fixes

-   fixed date cloning ([#275](https://github.com/sapphiredev/utilities/issues/275)) ([53d1f86](https://github.com/sapphiredev/utilities/commit/53d1f86ee7ea6cb29020b9845cc265f92a99a28c))

### Features

-   change build system to tsup ([#270](https://github.com/sapphiredev/utilities/issues/270)) ([365a53a](https://github.com/sapphiredev/utilities/commit/365a53a5517a01a0926cf28a83c96b63f32ed9f8))

## [3.2.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.2.0...@sapphire/utilities@3.2.1) (2022-01-21)

### Bug Fixes

-   fixed typos of `communitys` ([e4e3a69](https://github.com/sapphiredev/utilities/commit/e4e3a6913a8157f24f366ac43db46faebdc085ce)), closes [#263](https://github.com/sapphiredev/utilities/issues/263)

# [3.2.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.1.0...@sapphire/utilities@3.2.0) (2022-01-10)

### Bug Fixes

-   **utilities:** make `NonNullObject` require object ([#242](https://github.com/sapphiredev/utilities/issues/242)) ([5e0f161](https://github.com/sapphiredev/utilities/commit/5e0f161145402e01b631a9b1b2033d0618cccc8b))

### Features

-   **utilities:** support custom constructors for `isObject` ([#241](https://github.com/sapphiredev/utilities/issues/241)) ([701c2c2](https://github.com/sapphiredev/utilities/commit/701c2c200f147d7d7dcccaee65b75e709b601f8c))

# [3.1.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.8...@sapphire/utilities@3.1.0) (2021-11-19)

### Features

-   add array partitioning ([#220](https://github.com/sapphiredev/utilities/issues/220)) ([42d6b81](https://github.com/sapphiredev/utilities/commit/42d6b8123233ed5315c55412d993fc19266660bb))

## [3.0.8](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.7...@sapphire/utilities@3.0.8) (2021-11-15)

### Bug Fixes

-   **utilities:** target ES2019 for create-react-app support ([95575ed](https://github.com/sapphiredev/utilities/commit/95575ed5bc2def07fb8066d85662a08d8610d8d1))

## [3.0.7](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.6...@sapphire/utilities@3.0.7) (2021-11-06)

**Note:** Version bump only for package @sapphire/utilities

## [3.0.6](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.5...@sapphire/utilities@3.0.6) (2021-10-28)

### Bug Fixes

-   **deepClone:** fixed deep cloning when there are classes ([d3aeed1](https://github.com/sapphiredev/utilities/commit/d3aeed1613ae642ca96b1bd6914f0d43c7c35807))

## [3.0.5](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.4...@sapphire/utilities@3.0.5) (2021-10-26)

**Note:** Version bump only for package @sapphire/utilities

## [3.0.4](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.3...@sapphire/utilities@3.0.4) (2021-10-17)

### Bug Fixes

-   allow more node & npm versions in engines field ([5977d2a](https://github.com/sapphiredev/utilities/commit/5977d2a30a4b2cfdf84aff3f33af03ffde1bbec5))

## [3.0.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.2...@sapphire/utilities@3.0.3) (2021-10-11)

**Note:** Version bump only for package @sapphire/utilities

## [3.0.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.1...@sapphire/utilities@3.0.2) (2021-10-08)

### Bug Fixes

-   **utilities:** correct forgotten abstract ([#195](https://github.com/sapphiredev/utilities/issues/195)) ([20b7ef7](https://github.com/sapphiredev/utilities/commit/20b7ef7d22d88a7fe54ae40474fa58ab85c49488))

## [3.0.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@3.0.0...@sapphire/utilities@3.0.1) (2021-10-04)

### Bug Fixes

-   **utilities:** add AbstractCtor and AbstractConstructor and remove abstract from their counterparts ([dbc0321](https://github.com/sapphiredev/utilities/commit/dbc032169791bbdc70eb2a8f151098d21fa192fd))
-   **utilities:** support abstract classes for Ctor utility type ([1ce3136](https://github.com/sapphiredev/utilities/commit/1ce3136165aea830460ae5283d8348fef17c0dba))

# [3.0.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@2.0.1...@sapphire/utilities@3.0.0) (2021-10-04)

### Bug Fixes

-   **utilities:** rename `Awaited<T>` to `Awaitable<T>` ([#193](https://github.com/sapphiredev/utilities/issues/193)) ([6ff3e28](https://github.com/sapphiredev/utilities/commit/6ff3e28a78cc9c2b3d58d42fbfba876ab70046c2))

### Features

-   **utilities:** add empty array to 'isNullishOrEmpty' ([#168](https://github.com/sapphiredev/utilities/issues/168)) ([8f9e615](https://github.com/sapphiredev/utilities/commit/8f9e6156a802c90495f6f07ce6570226af01794c))
-   **utilities:** set minimum NodeJS to v14 ([79aa230](https://github.com/sapphiredev/utilities/commit/79aa230a5874d1bbfb14c3b8506de06b3329395a))
-   **utilities:** support abstract classes for `Constructor` utility type ([#194](https://github.com/sapphiredev/utilities/issues/194)) ([732d5a0](https://github.com/sapphiredev/utilities/commit/732d5a07b6eef9c37ee52a42f4a391764a08debf))

### BREAKING CHANGES

-   **utilities:** `Awaited` has been renamed to `Awaitable`

## [2.0.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@2.0.0...@sapphire/utilities@2.0.1) (2021-07-20)

### Bug Fixes

-   **utilities:** add tsdoc for filter functions ([36d51d1](https://github.com/sapphiredev/utilities/commit/36d51d12366dd25fa2f04a90e834b5fc2aac73ac))

# [2.0.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.7.0...@sapphire/utilities@2.0.0) (2021-07-17)

### Code Refactoring

-   **rateLimits:** rewrite all of it ([#130](https://github.com/sapphiredev/utilities/issues/130)) ([320778c](https://github.com/sapphiredev/utilities/commit/320778ca65cbf3591bd1ce0b1f2eb430693eef9a))

### BREAKING CHANGES

-   **rateLimits:** Removed `Bucket`

# [1.7.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.6.1...@sapphire/utilities@1.7.0) (2021-07-11)

### Features

-   **utilities:** add 3 new helper methods ([4ebcd43](https://github.com/sapphiredev/utilities/commit/4ebcd431cede7773aed2fe82e58c0d2d66578fea))

## [1.6.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.6.0...@sapphire/utilities@1.6.1) (2021-06-27)

**Note:** Version bump only for package @sapphire/utilities

# [1.6.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.5.3...@sapphire/utilities@1.6.0) (2021-06-19)

### Features

-   **utilities:** update utilities with more stuff ([#122](https://github.com/sapphiredev/utilities/issues/122)) ([5dfb668](https://github.com/sapphiredev/utilities/commit/5dfb6688d27ab361a7c31692465ed613b500cdb1))

## [1.5.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.5.2...@sapphire/utilities@1.5.3) (2021-06-06)

### Bug Fixes

-   remove peer deps, update dev deps, update READMEs ([#124](https://github.com/sapphiredev/utilities/issues/124)) ([67256ed](https://github.com/sapphiredev/utilities/commit/67256ed43b915b02a8b5c68230ba82d6210c5032))

## [1.5.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.5.1...@sapphire/utilities@1.5.2) (2021-05-20)

### Bug Fixes

-   **utilities:** mark package as side effect free ([73cbabd](https://github.com/sapphiredev/utilities/commit/73cbabddc274387d7819d80afe426eb1112f7995))

## [1.5.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.5.0...@sapphire/utilities@1.5.1) (2021-05-02)

### Bug Fixes

-   drop the `www.` from the SapphireJS URL ([494d89f](https://github.com/sapphiredev/utilities/commit/494d89ffa04f78c195b93d7905b3232884f7d7e2))
-   update all the SapphireJS URLs from `.com` to `.dev` ([f59b46d](https://github.com/sapphiredev/utilities/commit/f59b46d1a0ebd39cad17b17d71cd3b9da808d5fd))

# [1.5.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.8...@sapphire/utilities@1.5.0) (2021-04-21)

### Bug Fixes

-   **utilities:** resolve lgtm error ([eb5f4e6](https://github.com/sapphiredev/utilities/commit/eb5f4e6478d35a6864427fe02849e930b151285c))

### Features

-   add @sapphire/embed-jsx ([#100](https://github.com/sapphiredev/utilities/issues/100)) ([7277a23](https://github.com/sapphiredev/utilities/commit/7277a236015236ed8e81b7882875410facc4ce17))

## [1.4.8](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.7...@sapphire/utilities@1.4.8) (2021-04-19)

### Bug Fixes

-   change all Sapphire URLs from "project"->"community" & use our domain where applicable 👨‍🌾🚜 ([#102](https://github.com/sapphiredev/utilities/issues/102)) ([835b408](https://github.com/sapphiredev/utilities/commit/835b408e8e57130c3787aca2e32613346ff23e4d))

## [1.4.7](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.6...@sapphire/utilities@1.4.7) (2021-04-03)

**Note:** Version bump only for package @sapphire/utilities

## [1.4.6](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.5...@sapphire/utilities@1.4.6) (2021-03-16)

### Bug Fixes

-   remove terser from all packages ([#79](https://github.com/sapphiredev/utilities/issues/79)) ([1cfe4e7](https://github.com/sapphiredev/utilities/commit/1cfe4e7c804e62c142495686d2b83b81d0026c02))

## [1.4.5](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.4...@sapphire/utilities@1.4.5) (2021-02-16)

**Note:** Version bump only for package @sapphire/utilities

## [1.4.4](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.3...@sapphire/utilities@1.4.4) (2021-01-25)

**Note:** Version bump only for package @sapphire/utilities

## [1.4.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.2...@sapphire/utilities@1.4.3) (2021-01-16)

**Note:** Version bump only for package @sapphire/utilities

## [1.4.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.1...@sapphire/utilities@1.4.2) (2021-01-14)

### Bug Fixes

-   **utilities:** fix parseUrl not working in v1.4.1 ([c1fe990](https://github.com/sapphiredev/utilities/commit/c1fe990d443b20791d268a2ca2bdd645500ed436))

## [1.4.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.4.0...@sapphire/utilities@1.4.1) (2021-01-14)

### Bug Fixes

-   **utilities:** fixed return type for parseURL ([718065a](https://github.com/sapphiredev/utilities/commit/718065a34b5ee225503f8b2197784f1fd1b15f19))
-   **utilities:** properly type parseUrl ([dcf800f](https://github.com/sapphiredev/utilities/commit/dcf800f6e1435cd6151f510da36b9e99166df9e4))

# [1.4.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.3.1...@sapphire/utilities@1.4.0) (2021-01-13)

### Features

-   **utilities:** add Nullish utility type ([a7e32bd](https://github.com/sapphiredev/utilities/commit/a7e32bdc1475840d6c313fbb83b7e502ebf780f5))

## [1.3.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.3.0...@sapphire/utilities@1.3.1) (2021-01-01)

**Note:** Version bump only for package @sapphire/utilities

# [1.3.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.2.0...@sapphire/utilities@1.3.0) (2020-12-26)

### Features

-   **decorators:** add createFunctionPrecondition, fixed build ([#51](https://github.com/sapphiredev/utilities/issues/51)) ([c87d5db](https://github.com/sapphiredev/utilities/commit/c87d5db8e29bbfcf96a29e34e4e4186426bac304))

# [1.2.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.1.1...@sapphire/utilities@1.2.0) (2020-12-22)

### Features

-   **utilities:** add debounce ([#45](https://github.com/sapphiredev/utilities/issues/45)) ([4762ebf](https://github.com/sapphiredev/utilities/commit/4762ebfac1724308330a61d2c8b3d71eadbd24f0))

## [1.1.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.1.0...@sapphire/utilities@1.1.1) (2020-11-15)

### Bug Fixes

-   **utilities:** add alias of isNullish to isNullOrUndefined ([eadf28f](https://github.com/sapphiredev/utilities/commit/eadf28ff024d887d83ade252e4567317593ca529)), closes [#30](https://github.com/sapphiredev/utilities/issues/30)
-   **utilities:** pass keep_classnames to terser ([9425c82](https://github.com/sapphiredev/utilities/commit/9425c82765b2fda461d08ab1d5ed4a302d327281))
-   **utilities:** pass keep_fnames to terser ([4b8fde2](https://github.com/sapphiredev/utilities/commit/4b8fde225fc7fb8da26dd51bc1ab97b6d45f6af5))

# [1.1.0](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.0.3...@sapphire/utilities@1.1.0) (2020-11-07)

### Features

-   **utilities:** add range function ([f9ac35e](https://github.com/sapphiredev/utilities/commit/f9ac35ee74848746ce057a1c2a8ccc6499aca892))
-   **utilities:** add range function ([a59d623](https://github.com/sapphiredev/utilities/commit/a59d62341d64c4b1565637d15cd642efd275281a))
-   added time-utilities package ([#26](https://github.com/sapphiredev/utilities/issues/26)) ([f17a333](https://github.com/sapphiredev/utilities/commit/f17a3339667a452e8745fad7884272176e5d65e8))

## [1.0.3](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.0.2...@sapphire/utilities@1.0.3) (2020-11-04)

### Bug Fixes

-   **utilities:** properly specify ESM and CommonJS exports ([11f4f9b](https://github.com/sapphiredev/utilities/commit/11f4f9b32f8c2a6c8be2f4568e2e1e0fac47b39e))

## [1.0.2](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.0.1...@sapphire/utilities@1.0.2) (2020-10-11)

### Bug Fixes

-   **ratelimits,snowflake,utilities:** fixed esm output target ([9fdab3f](https://github.com/sapphiredev/utilities/commit/9fdab3fca283c8c0b47cc32661c5cf8e0a5e583c))
-   **utilities:** fixed up mergeDefault ([#21](https://github.com/sapphiredev/utilities/issues/21)) ([76561db](https://github.com/sapphiredev/utilities/commit/76561dbf339ebf2dff1a712e448407e6a1b36070))

## [1.0.1](https://github.com/sapphiredev/utilities/compare/@sapphire/utilities@1.0.0...@sapphire/utilities@1.0.1) (2020-09-20)

**Note:** Version bump only for package @sapphire/utilities

# 1.0.0 (2020-09-05)

### Bug Fixes

-   **utilities:** fix types for isFunction ([991de0d](https://github.com/sapphiredev/utilities/commit/991de0da0f9b51813f4fee4ecf071feeb9d95abe))
-   **utilities:** fixed types for codeBlock ([abae927](https://github.com/sapphiredev/utilities/commit/abae927f5a5dbf1785770569d0fc6bcdf658880e))
-   **utilities:** fixed types for isThenable ([0563b8d](https://github.com/sapphiredev/utilities/commit/0563b8dc0492fe8ff5dd3fc16dd334854d962728))
-   **utilities:** put lang as first param ([54bfba7](https://github.com/sapphiredev/utilities/commit/54bfba781ac7d6f9d60fc7fec85475d8496d9aa2))

### Features

-   implement snowflake ([5ba4e2d](https://github.com/sapphiredev/utilities/commit/5ba4e2d82557dd4ff60ffe891a7b46e46373bea2))
-   **decorators:** add decorators package ([#4](https://github.com/sapphiredev/utilities/issues/4)) ([677b3e5](https://github.com/sapphiredev/utilities/commit/677b3e59d5c6160cbe6fb410821cadd7c0f00e3c))
-   **utilities:** add all utilities ([94fcae8](https://github.com/sapphiredev/utilities/commit/94fcae8cb81e0eaaddac7de1e78b1e26cccb9bf0))
