'use strict';

var isFunction_cjs = require('./isFunction.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function partition(array, predicate) {
  if (!Array.isArray(array))
    throw new TypeError("entries must be an array.");
  if (!isFunction_cjs.isFunction(predicate))
    throw new TypeError("predicate must be an function that returns a boolean value.");
  const partitionOne = [];
  const partitionTwo = [];
  for (let i = 0; i < array.length; i++) {
    if (predicate(array[i], i)) {
      partitionOne.push(array[i]);
    } else {
      partitionTwo.push(array[i]);
    }
  }
  return [partitionOne, partitionTwo];
}
__name(partition, "partition");

exports.partition = partition;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=partition.cjs.map